//+------------------------------------------------------------------+
//|                                             _CloseAllProfits.mq4 |
//|                                              (  ) |
//|                                           "  " |
//|              Buy  Sell   , |
//|                  ,  Slippage  MyPips |
//|                            (MyPips     ) |
//|                           Bookkeeper, 2007, yuzefovich@gmail.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property show_confirm //     Slippage  
//    - :        //#property show_confirm
//----
extern int Slippage = 3;     // 
extern int MyPips   = 2;    //     
//----
int start()
{
double price,pnt;
bool   Result;
int    i,pos,sign,Error,Total;
string symbol_i;
color  c;
//----
  if(Slippage<1) Slippage=1;
  if(MyPips<0) MyPips=0;
  Total=OrdersTotal();
  if(Total>0)
  {
     for(i=Total-1; i>=0; i--) 
     {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
        {
           pos=OrderType();
           if(pos<2) 
           {
              symbol_i=OrderSymbol();
              pnt=MarketInfo(symbol_i,MODE_POINT);
              RefreshRates();
              if(pos==OP_BUY)
              {
                 sign=1; 
                 price=MarketInfo(symbol_i,MODE_BID);
                 c=Blue;
              }
              else
              {
                 sign=-1; 
                 price=MarketInfo(symbol_i,MODE_ASK);
                 c=Magenta;
              }
              if((price-OrderOpenPrice())*sign>pnt*(Slippage+MyPips))
              {
                 Result=OrderClose(OrderTicket(),
                                   OrderLots(),
                                   price,
                                   Slippage,
                                   c);
                 if(Result!=true) 
                 { 
                    Error=GetLastError(); 
                    Alert("CloseAllSymbols LastError = ",Error); 
                 }
                 else Error=0;
              }
           }
        }
     }
  }
  return(0);
}
//+------------------------------------------------------------------+